import 'package:json_annotation/json_annotation.dart';
import 'package:lori_sdk/data/models/trustDefenderConfiguration.dart';
import 'package:lori_sdk/data/models/product/productOrder.dart';

part 'configurations.g.dart';

@JsonSerializable()
class Configurations {
  Configurations();

  bool showUnavailableProducts;
  int minStock;
  int daysIsNewRole;
  String apiVersion;
  bool showSkuSelector;
  bool hasDealerCode = false;
  bool showReaderCodeBar = false;
  bool enableSDKCybersource = false;
  double displayRadius = 0.0;
  bool isShowSubCategories = false;
  ProductOrder catalogSort = ProductOrder.none;
  bool buyWithOneClick = true;
  String checkoutPaymentAlertText;
  bool forceSellerNameAtList = false;

  @JsonKey(name: 'sdkCybersourceConfiguration')
  TrustDefenderConfiguration trustDefenderConfiguration;

  factory Configurations.fromJson(Map<String, dynamic> json) =>
      _$ConfigurationsFromJson(json);

  Map<String, dynamic> toJson() => _$ConfigurationsToJson(this);
}
