import 'dart:async';

import 'package:lori_sdk/data/database/interfaces/productDao.dart';
import 'package:lori_sdk/data/models/product/product.dart';

class ProductSingleton {
  // Singleton part
  static final ProductSingleton _singleton = ProductSingleton._internal();

  factory ProductSingleton() {
    return _singleton;
  }

  ProductSingleton._internal();

  // Class part
  // ignore: close_sinks
  var _productStream = StreamController<List<Product>>.broadcast(sync: true);

  Future<StreamSubscription<List<Product>>> registerToStream(
      Function callback) async {
    StreamSubscription<List<Product>> subscriptions =
        _productStream.stream.listen(callback);
    // Make sure to call cart changed this time
    //var product = await ProductDao().get();
    List<Product> products = await ProductDao().get();
    productsChanged(products);
    return subscriptions;
  }

  void productsChanged(List<Product> products) {
    _productStream.sink.add(products);
  }

  void productClose() async {
    await _productStream.sink.close();
  }
}
